wxyzv:  yet another image viewer
================================

Copyright (C) 1999 David Flater

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

Why this exists
---------------

I made wxyzv in 1999 so I could efficiently review a large number of JPEGs.
It later found use as a way to quickly display a png screenshot in a window
for reference while I work on something else.

Then and now, I found the widely-available desktop image viewers to be
bloated, complicated, cumbersome, and slow for what I needed to do.  Although
the computational overhead of scaling and displaying large images is no
longer a factor, wxyzv still wins on ergonomics.

Where to find it
----------------

Source distribution:  <https://flaterco.com/files/wxyzv/>  
Copy of the README:   <https://flaterco.com/wxyzv.html>

Requirements
------------

* X11
* True color display at least 15 bits deep
* IJG libjpeg or libjpeg-turbo
* libpng
* C++ compiler

Features
--------

* Supports JPEG, PNG, and raw PPM with maxval=255
* Provides rotation, gamma adjustment, sharpening, and nonlinear smoothing
* Makes best effort on corrupted JPEGs and PNGs
* Centers image on screen
* Efficiently downscales oversized JPEGs

Limitations
-----------

* Scaling ratios for JPEGs are limited by libjpeg capabilities
* No scaling of PNG or PPM input
* No panning of oversized images
* Will not use anything but a true color visual
* Chokes on PNM other than raw PPM with maxval=255
* PNGs with "clever" attributes will get one of the following:
  - Flattened to 24-bit RGB
  - Mangled
  - Segmentation fault

Installation
------------

wxyzv is packaged with the popular and portable GNU Automake, so all usual
GNU tricks should work.  Help on configuration options can be found in the
INSTALL file or obtained by entering `./configure --help`.

Normally, one should only need to do the following to compile and install
wxyzv:

    bash$ ./configure
    bash$ make
    bash$ su
    bash# make install

Usage
-----

    wxyzv file [file...]

    space                            go to next image
    p or P                           go back to previous image
    q or Q                           quit
    up arrow / mouse roller          adjust gamma (brighter)
    down arrow / mouse roller        adjust gamma (darker)
    left arrow / mouse button        smoother
    right arrow / mouse button       sharper
    r                                rotate clockwise
    R                                rotate counterclockwise
    f or F                           toggle JPEG scaling
    m or M                           toggle NetWM fullscreen

The fullscreen button does not affect the scale of the displayed image.
Fullscreen mode is enabled by default just to stop the window manager from
overriding the size and position of the window.  Toggling it off brings back
the window decorations and enables manual repositioning, but the window
manager may force the window to a smaller size, causing the bottom or side of
the image to be cut off.

Maintenance
-----------

Send bug reports to dave@flaterco.com.

There is no time budgeted to add features to this program since many
full-featured alternatives already exist.

Change log
----------

### wxyzv 1.2 (2022-06-11)

* Fixed compatibility with libjpeg-turbo and IJG libjpeg.
  - Removed check for v8 of the IJG libjpeg API.
  - Restored compatibility with IJG libjpeg v6.
  - Worked with different initialization of `scale_num` and `scale_denom` by
    libjpeg-turbo.
  - Enabled the v7+ scaling ratios in libjpeg-turbo even when the API is v6.
  - Fixed FTB caused by a boolean type clash introduced in IJG libjpeg v9.
* Enabled JPEG upscaling (previously found to be too artifacty).
* Fixed compatibility with KWin.
  - Added support for NetWM.
  - Enabled WM fullscreen mode by default.
  - Set hints to fix the window size.
  - Set `XLIB_SKIP_ARGB_VISUALS=1` to fix transparency problem.
  - Nerfed the 'f' button to avoid glitching KWin/Plasma.  
    (With Fvwm* window managers, you could navigate oversized images using
    the desktop pager or by moving the window around.  Unfortunately,
    something in the KWin/Plasma/OpenGL stack glitches out if you realize a
    window that is larger than the screen, so the window size is now limited
    and navigation is no longer possible.)
* Added 'm' button to toggle WM fullscreen mode.
* Cleaned up code.
* Converted README to Markdown.
* Updated build scripts.

Unsolved problem:

* Under XWayland, the first image appears almost completely transparent.  The
  problem goes away as soon as you interact with wxyzv (e.g., by going to the
  second image or by toggling f).

### wxyzv 1.1.1 (2011-03-30)

* Relicensed under GPLv3.
* Fixed segfault occurring on x86-64.
* Fixed jpeg scaling, which was broken by changes made in libjpeg version 7.
  Version 8 of libjpeg is now required.
* Fixed libpng deprecation.
* Automake'd the build process.
* Random cleanups.

### wxyzv 1.1 (2006-04-09)

Added rotation feature.  Fixed miscellaneous code rot.

### wxyzv 1.0 r2 (2005-06-16)

Documentation changes only:  updated e-mail address, synced with web
page.

### wxyzv 1.0 (2000-01-02)
